package com.eactive.eai.adapter.socket2.protocol.login.codec;

import org.apache.mina.common.ByteBuffer;
import org.apache.mina.common.IdleStatus;
import org.apache.mina.common.IoSession;
import org.apache.mina.filter.codec.ProtocolDecoderAdapter;
import org.apache.mina.filter.codec.ProtocolDecoderOutput;

import com.eactive.eai.adapter.EAIException;
import com.eactive.eai.adapter.socket2.common.CommonLib;
import com.eactive.eai.adapter.socket2.common.SMSLogger;
import com.eactive.eai.adapter.socket2.config.SocketAdapterContext;
import com.eactive.eai.adapter.socket2.config.SocketLoggerManager;
import com.eactive.eai.adapter.socket2.protocol.ByteMessage;
import com.eactive.eai.adapter.socket2.protocol.ISocketAdapter;
import com.eactive.eai.adapter.socket2.protocol.ProtocolHandler;
import com.eactive.eai.common.util.Logger;

public class BindDecoder extends ProtocolDecoderAdapter  {
	protected final Logger logger;
	protected final Logger errLogger;
	
	public static final int MAX_PAYLOAD_SIZE = 100 * 1024;   // 100KB

	private static final String DECODER_STATE_KEY = BindDecoder.class.getName() + ".STATE";

	private enum State {
		STATE_HEADER_READ, STATE_PAYLOAD_READ;
	}

	private static class CodecState {
		State       state = State.STATE_HEADER_READ; 
		ByteBuffer 	buffer = ByteBuffer.allocate(0).setAutoExpand(true);
		int      	payloadSize;
	}
	
	SocketAdapterContext context;
	ISocketAdapter adapter;

	public BindDecoder(ISocketAdapter adapter) {
		this.adapter = adapter;
		this.context = adapter.getContext();

	    logger    = SocketLoggerManager.getInstance().getLogger(context.getAdapterGroupName());
	    errLogger = SocketLoggerManager.getInstance().getErrLogger();
	}

	@SuppressWarnings("static-access")
	public void decode(IoSession session, ByteBuffer in, ProtocolDecoderOutput out) throws Exception {
		CodecState codecState = (CodecState) session.getAttribute(DECODER_STATE_KEY);
		if (codecState == null) {
			codecState = new CodecState();
			codecState.buffer.limit(context.getLlFieldOffset() + context.getLlFieldLength());
			session.setAttribute(DECODER_STATE_KEY, codecState);
		}

		if ( context.getTraceLevel() >= context.TRACE_LEVEL_TRACE ) {
			StringBuilder sb = new StringBuilder();
			sb.append("FixedHeaderDecoder");
			//sb.append(codecState.state);
			if (codecState.state == State.STATE_PAYLOAD_READ) {
				sb.append("(" + codecState.payloadSize + ")");
			}
			sb.append(" | decode : " + CommonLib.hexDump(in, context));
			logger.debug(sb.toString());
			adapter.addRecentRecvTrace(session, sb.toString());
		}

		while(in.hasRemaining()) {
			session.setIdleTime(IdleStatus.BOTH_IDLE, context.getTimeout());

			switch (codecState.state) {
			case STATE_HEADER_READ:		
				if (readHeader(session, codecState, in)) {
					/**
					 * payload size < 0 인 경우
					 */
					if (codecState.payloadSize < 0) {
						throw new EAIException("RECEAINNA008", context.getAdapterName() +
								" (" + context.getLlFieldType() + "," + context.getLlFieldOffset() + "," + context.getLlFieldLength() +
								") | when read header, ll length field is invalid | " + CommonLib.hexDump(codecState.buffer, context));						
					/**
					 * payload size == 0 인 경우
					 */
					} else if (codecState.payloadSize == 0) {
						if (context.isSync()) {
							throw new Exception("<RECV> payload size 0 (ping). 'SYNC' response type socket does not support ping(size 0) message.");
						}

			 			//codecState.state = State.STATE_HEADER_READ;
						session.setAttribute(ProtocolHandler.CODEC_STATE, codecState.state.toString());

			 			if ( context.getTraceLevel() >= context.TRACE_LEVEL_INFO ) {
							logger.info(context.getAdapterName() + " | <RECV> payload size 0 (ping) -> ignore. - " + CommonLib.hexDump(in, context));
							adapter.addRecentRecvTrace(session, "payload size 0 (ping) -> ignore. - " + CommonLib.hexDump(in, context));
						}

			 			/**
						 * header 값을 읽은 후 buffer의 position을 이동해 준다.
						 * 이 작업을 안해주면 무한루프에 빠질 수 있다.
						 * 예) 법원 공탁금 (_LAW_IN_SOC_AsS{...})
						 */
						codecState.buffer.position(0).limit(context.getLlFieldOffset() + context.getLlFieldLength());
						
						//by short11
						//polling.role 이 Server 가 sender일 경우 오류가 있었음
						if (context.isPollingUse() && context.isPollingSender() && context.isPermanent()) {
							session.setIdleTime(IdleStatus.BOTH_IDLE, context.getPollingTimeout());
						}else{
							session.setIdleTime(IdleStatus.BOTH_IDLE, context.getIdleTimeout());
						}
//						if (context.isClient() && context.isPermanent() && context.isPollingUse()) {
//							session.setIdleTime(IdleStatus.BOTH_IDLE, context.getPollingTimeout());
//						} else {
//							session.setIdleTime(IdleStatus.BOTH_IDLE, context.getIdleTimeout());
//						}

						break;
					}
					
					/**
					 * ll.include = 'Y' - LL을 포함해서 넘긴다.
					 */
					if ("Y".equals(context.getLlInclude())) {
						try {
							codecState.buffer.position(context.getLlFieldOffset() + context.getLlFieldLength())
							                   .limit(codecState.payloadSize + context.getLlFieldLength());
						} catch(IllegalArgumentException e) {
							StringBuilder sb = new StringBuilder();
							sb.append(context.getAdapterName() + " | error when handling buffer | ");							
							sb.append("offset=" + context.getLlFieldOffset() + context.getLlFieldLength());
							sb.append(", limit=" + codecState.payloadSize + context.getLlFieldLength());
							logger.error(sb.toString());
			    			errLogger.error(sb.toString());
			    			adapter.addRecentError(sb.toString());
//			    			SMSLogger.loggingSMSWithCode(context.getAdapterName(), "RECEAINNA007");
			    			SMSLogger.loggingSMS4Soc(context.getAdapterName(), context.getDescription(), "RECEAINNA007");
							throw e;
						}
					/**
					 * ll.include = 'N' - LL을 제외하고 넘긴다.
					 */
					} else {
						try {
							codecState.buffer.position(context.getLlFieldOffset()).limit(codecState.payloadSize);
						} catch(IllegalArgumentException e) {
							StringBuilder sb = new StringBuilder();
							sb.append(context.getAdapterName() + " | error when handling buffer | ");
							sb.append("offset=" + context.getLlFieldOffset());
							sb.append(", limit=" + codecState.payloadSize);
							logger.error(sb.toString());
			    			errLogger.error(sb.toString());
			    			adapter.addRecentError(sb.toString());
			    			SMSLogger.loggingSMS4Soc(context.getAdapterName(), context.getDescription(), "RECEAINNA007");
							throw e;
						}
					}
					
					/**
					 * offset + ll 을 읽었고, 더 이상 읽을 것(payload)이 없는 경우
					 * - ll.length value = ll.offset + ll.field.length
					 */
					if (codecState.buffer.position() == codecState.buffer.limit()) {
						byte[] bytes = new byte[codecState.buffer.limit()];
						codecState.buffer.position(0);
						codecState.buffer.get(bytes);
						ByteMessage message = new ByteMessage(bytes);		
						out.write(message);
						codecState.buffer.position(0).limit(context.getLlFieldOffset() + context.getLlFieldLength());
						
						
						
						//by short11
						//polling.role 이 Server 가 sender일 경우 오류가 있었음
						if (context.isPollingUse() && context.isPollingSender() && context.isPermanent()) {
							session.setIdleTime(IdleStatus.BOTH_IDLE, context.getPollingTimeout());
						}else{
							session.setIdleTime(IdleStatus.BOTH_IDLE, context.getIdleTimeout());
						}
						
//						if (context.isClient() && context.isPermanent() && context.isPollingUse()) {
//							session.setIdleTime(IdleStatus.BOTH_IDLE, context.getPollingTimeout());
//						} else {
//							session.setIdleTime(IdleStatus.BOTH_IDLE, context.getIdleTimeout());
//						}
						
						break;
					}
						
					codecState.state = State.STATE_PAYLOAD_READ;
					session.setAttribute(ProtocolHandler.CODEC_STATE, codecState.state.toString());
				}
				break;
			case STATE_PAYLOAD_READ:
				if (readPayload(session, codecState, in)) {
					byte[] bytes = new byte[codecState.buffer.limit()];
					codecState.buffer.position(0);
					codecState.buffer.get(bytes);
					ByteMessage message = new ByteMessage(bytes);
					out.write(message);
					
					codecState.buffer.position(0).limit(context.getLlFieldOffset() + context.getLlFieldLength());
					
					//by short11
					//polling.role 이 Server 가 sender일 경우 오류가 있었음
					if (context.isPollingUse() && context.isPollingSender() && context.isPermanent()) {
						session.setIdleTime(IdleStatus.BOTH_IDLE, context.getPollingTimeout());
					}else{
						session.setIdleTime(IdleStatus.BOTH_IDLE, context.getIdleTimeout());
					}
					
					
//					if (context.isClient() && context.isPermanent() && context.isPollingUse()) {
//						session.setIdleTime(IdleStatus.BOTH_IDLE, context.getPollingTimeout());
//					} else {
//						session.setIdleTime(IdleStatus.BOTH_IDLE, context.getIdleTimeout());
//					}
		 			codecState.state = State.STATE_HEADER_READ;
					session.setAttribute(ProtocolHandler.CODEC_STATE, codecState.state.toString());
				}
				
				break;
			}
			
			session.setAttribute(ProtocolHandler.CODEC_STATE_BUFFER, CommonLib.hexDumpRead(codecState.buffer, context));
		}
	}
	private boolean readHeader(IoSession session, CodecState codecState, ByteBuffer in) throws Exception {
		/*
		if ( context.getTraceLevel() >= context.TRACE_LEVEL_TRACE ) {
			logger.debug(context.getAdapterName() + " | read header : " + in);
		}
		*/

        if (codecState.buffer.remaining() > in.remaining()) {
        	codecState.buffer.put(in);
            return false;
        }

    	while(codecState.buffer.hasRemaining()) {
    		codecState.buffer.put(in.get());
    	}
    	
		if ("BIN".equals(context.getLlFieldType())) {
			codecState.payloadSize = 0;
			for (int i=0; i<context.getLlFieldLength(); i++) {
				codecState.payloadSize += ((int) codecState.buffer.get(context.getLlFieldOffset() + i) & 0xFF) * Math.pow(256, context.getLlFieldLength()-i-1);
			}
		} else { // "CHAR"
			codecState.buffer.flip();
			try {
				byte[] header = new byte[context.getLlFieldLength()];				
				for (int i=0; i<context.getLlFieldLength(); i++) {
					header[i] = codecState.buffer.get(context.getLlFieldOffset() + i);
				}
				codecState.payloadSize = Integer.parseInt(new String(header));
			} catch (NumberFormatException e) {
//				SMSLogger.loggingSMSWithCode(context.getAdapterName(), "RECEAINNA008");
				SMSLogger.loggingSMS4Soc(context.getAdapterName(), context.getDescription(), "RECEAINNA008");
				throw new EAIException("RECEAINNA008", context.getAdapterName() +
						" (" + context.getLlFieldType() + "," + context.getLlFieldOffset() + "," + context.getLlFieldLength() 
						+ ") | when read header, number format is invalid - " 
						+ e.getMessage() + " | " + CommonLib.hexDump(codecState.buffer, context));
			}
		}
		
		if (codecState.payloadSize > MAX_PAYLOAD_SIZE) {
			throw new Exception("max payload size(" + MAX_PAYLOAD_SIZE + ") exceeded : " + 
					            codecState.payloadSize + " | " + 
					            CommonLib.hexDump(codecState.buffer, context));
		}
		
		/**
		 * ll.field.include = 'Y' - 헤더 길이를 빼 준다.
		 */
		if ("Y".equals(context.getLlFieldInclude())) {
			codecState.payloadSize = codecState.payloadSize - context.getLlFieldLength();
		}
		
		/**
		 * ll.offset.exclude = 'Y' - offset 만큼의 크기를 더해서 length를 계산한다.
		 */
		if ("Y".equals(context.getLlOffsetExclude())) {
			codecState.payloadSize = codecState.payloadSize + context.getLlFieldOffset();
		}
		//길이 계산 로직에 추가하면 됨
		if (context.getLlFieldLengthAlpha() != 0 ){
			codecState.payloadSize = codecState.payloadSize - context.getLlFieldLengthAlpha();
		}			

		return true;
	}

	private boolean readPayload(IoSession session, CodecState codecState, ByteBuffer in) throws Exception {
		/*
		if ( context.getTraceLevel() >= context.TRACE_LEVEL_TRACE ) {
			logger.debug(context.getAdapterName() + " | read payload : " + in);
		}
		*/

        if (codecState.buffer.remaining() > in.remaining()) {
        	codecState.buffer.put(in);
            return false;
        }
        
    	while(codecState.buffer.hasRemaining()) {
    		codecState.buffer.put(in.get());
    	}
		
		return true;
	}	
	
	
}
